function logp_A=log_post_A_ev(x,tt,id,G,Lambda,C,var_a)
%Compute log p(A|C,data)
A=G*Lambda*inv(G);
nsubjects=length(unique(id));
[nobs,dim]=size(x);
if(dim==2)
    sig=(det(A)*C+(A-trace(A)*eye(dim))*C*(A-trace(A)*eye(dim))')...
        ./(2*trace(A)*det(A));
else
    sig=lyap(A,-C);
end
nsub_obs=zeros(1,nsubjects);
for i=1:nsubjects
    nsub_obs(i)=sum(id==i);
end
sum1=0;
sum2=0;
for i=1:nsubjects
    ti=tt(find(id==i));
    xi=x(find(id==i),:);
    for j=2:nsub_obs(i)
        dt=ti(j)-ti(j-1);
        temp=expm(-A*dt);
        mu=temp*xi(j-1,:)';
        omega=sig-temp*sig*temp';
        sum1=sum1+log(det(omega));
        y=xi(j,:)'-mu;
        sum2=sum2+y'*inv(omega)*y;
    end
end
sum3=0;
for i=1:dim
    for j=1:dim
        if(i~=j)
           sum3=sum3+G(i,j)^2;
        end
    end
end
logp_A=-0.5*(sum1+sum2)-sum(log(diag(Lambda)))-...
         0.5*sum(log(diag(Lambda)).^2)/var_a-0.5*sum3/var_a;

