function logp_C=log_post_C_fda(x,tt,id,A,L,D,var_c)
%Compute log p(C|A,y)
nsubjects=length(unique(id));
[nobs,dim]=size(x);
C=L*D*L';
if(dim==2)
    sig=(det(A)*C+(A-trace(A)*eye(2))*C*(A-trace(A)*eye(2))')...
        ./(2*trace(A)*det(A));
else
    sig=lyap(A,-C);
end
nsub_obs=zeros(1,nsubjects);
for i=1:nsubjects
    nsub_obs(i)=sum(id==i);
end
sum1=0;
sum2=0;
for i=1:nsubjects
    ti=tt(find(id==i));
    xi=x(find(id==i),:);
    for j=2:nsub_obs(i)
        dt=ti(j)-ti(j-1);
        temp=expm(-A*dt);
        mu=temp*xi(j-1,:)';
        omega=sig-temp*sig*temp';
        sum1=sum1+log(det(omega));
        y=xi(j,:)'-mu;
        sum2=sum2+y'*inv(omega)*y;
    end
end
logp_C=-0.5*(sum1+sum2)-0.5*sum(sum(L.^2))/var_c-sum(log(diag(D)))-...  
        0.5*sum(log(diag(D)).^2)/var_c;

