function [beta_hat,u_hat]= mixed_mcmc(y,X,Z)
nloop=100;
nwarmup=50;
[nobs,nu]=size(Z);
[nobs,nb]=size(X);
C=[X Z];
CC=C'*C;
D=diag([zeros(1,nb) ones(1,nu)]);
A_eps=.01; B_eps=0.01;
A_u=.01; B_u=0.01;
var_eps=ones(1,nloop+1);
var_u=ones(1,nloop+1);
beta=zeros(nb,nloop);
u=zeros(nu,nloop);
for p=1:nloop
    mat1=inv(CC+(var_eps(p)/var_u(p))*D);
    mu=mat1*C'*y;
    sigma=var_eps(p)*mat1;
    sigma=0.5*(sigma+sigma');
    betau=mvnrnd(mu,sigma);
    beta(:,p)=betau(1:nb);
    u(:,p)=betau(nb+1:end);
    var_u(p+1)=1/gamrnd(A_u+nu/2,1/(B_u+0.5*sum(u(:,p).^2)));
    diff=y-X*beta(:,p)-Z*u(:,p);
    var_eps(p+1)=1/gamrnd(A_eps+nobs/2,1/(B_eps+0.5*sum(diff.^2)));
end
beta_hat=mean(beta(:,nwarmup+1:nloop),2)';
u_hat=mean(u(:,nwarmup+1:nloop),2)';
