function neg_logp_C=neg_log_post_C_fda(par,A,x,tt,id,var_c)
nsubjects=length(unique(id));
[nobs,dim]=size(x);
%par contains dim*(dim+1)/2 elements
%The first dim*(dim-1)/2 entries of par are the (columnwise) elements of L 
%(unit lower triangular). The last dim values of par are log(D_i)
nl=dim*(dim-1)/2;
L=eye(dim);
counter=0;
for j=1:dim-1
    for i=j+1:dim
        counter=counter+1;
        L(i,j)=par(counter);
    end
end
D=diag(exp(par(nl+1:nl+dim)));
C=L*D*L';
if(sum(sum(isinf(C))) > 0 | sum(sum(isnan(C)))>0 | cond(C)>10^5)
   neg_logp_C=10^5;
   return
end
if (dim==2)
    sig=(det(A)*C+(A-trace(A)*eye(2))*C*(A-trace(A)*eye(2))')...
        ./(2*trace(A)*det(A));
else
    sig=lyap(A,-C);
end
nsub_obs=zeros(1,nsubjects);
for i=1:nsubjects
    nsub_obs(i)=sum(id==i);
end
sum1=0;
sum2=0;
for i=1:nsubjects
    ti=tt(find(id==i));
    xi=x(find(id==i),:);
    for j=2:nsub_obs(i)
        dt=ti(j)-ti(j-1);
        temp=expm(-A*dt);
        mu=temp*xi(j-1,:)';
        omega=sig-temp*sig*temp';
        sum1=sum1+log(det(omega));
        y=xi(j,:)'-mu;
        sum2=sum2+y'*inv(omega)*y;
    end
end
logp_C=-0.5*(sum1+sum2)-0.5*sum(sum(L.^2))/var_c-sum(log(diag(D)))-...
        0.5*sum(log(diag(D)).^2)/var_c;
neg_logp_C=-logp_C;
